'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* global document, window */

var Modal = function (_React$Component) {
    _inherits(Modal, _React$Component);

    function Modal(props) {
        _classCallCheck(this, Modal);

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Modal).call(this, props));

        _this.onEscKeyDown = _this.onEscKeyDown.bind(_this);
        _this.fadeIn = _this.fadeIn.bind(_this);
        _this.cleanUp = _this.cleanUp.bind(_this);
        _this.state = {
            isOpen: false,
            isFadeIn: false
        };
        _this.timerIds = [];
        return _this;
    }

    _createClass(Modal, [{
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            this.cleanUp();
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (this.props.isOpen === nextProps.isOpen) return;

            if (nextProps.isOpen) this.open();else this.close();
        }
    }, {
        key: 'setUp',
        value: function setUp() {
            document.body.className = [document.body.className, 'modal-open'].join(' ');
            document.addEventListener('keydown', this.onEscKeyDown);
        }
    }, {
        key: 'cleanUp',
        value: function cleanUp() {
            this.setState({ isOpen: false });

            document.body.className = document.body.className.replace(/ ?modal-open/, '');
            document.removeEventListener('keydown', this.onEscKeyDown);

            this.timerIds.forEach(function (timerId) {
                window.clearTimeout(timerId);
            });
        }
    }, {
        key: 'open',
        value: function open() {
            this.setUp();
            this.setState({ isOpen: true });
            this.timerIds.push(window.setTimeout(this.fadeIn, 0));
        }
    }, {
        key: 'close',
        value: function close() {
            this.setState({ isFadeIn: false });

            // delay cleanup so animations can complete before closing
            this.timerIds.push(window.setTimeout(this.cleanUp, 300));
        }
    }, {
        key: 'fadeIn',
        value: function fadeIn() {
            this.setState({ isFadeIn: true });
        }
    }, {
        key: 'onEscKeyDown',
        value: function onEscKeyDown(evt) {
            if (evt.keyCode !== 27) return;

            this.props.close();
        }
    }, {
        key: 'handleClick',
        value: function handleClick(evt) {
            if (evt.target !== this.refs.modalContainer) return;

            evt.preventDefault();
            this.props.close();
        }
    }, {
        key: 'render',
        value: function render() {
            return _react2.default.createElement(
                'div',
                null,
                _react2.default.createElement(
                    'div',
                    {
                        ref: 'modalContainer',
                        onClick: this.handleClick.bind(this),
                        className: 'modal fade ' + (this.state.isFadeIn ? 'in' : ''),
                        style: { display: this.state.isOpen ? 'block' : 'none' }
                    },
                    _react2.default.createElement(
                        'div',
                        { className: 'modal-dialog modal-' + (this.props.size || 'lg') },
                        _react2.default.createElement(
                            'div',
                            { className: 'modal-content' },
                            this.props.children
                        )
                    )
                ),
                this.state.isOpen ? _react2.default.createElement('div', { className: 'modal-backdrop fade ' + (this.state.isFadeIn ? 'in' : '') }) : null
            );
        }
    }]);

    return Modal;
}(_react2.default.Component);

Modal.propTypes = {
    size: _react2.default.PropTypes.string,
    children: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.arrayOf(_react2.default.PropTypes.node), _react2.default.PropTypes.element]).isRequired,

    // from modal wrapper
    isOpen: _react2.default.PropTypes.bool.isRequired,
    close: _react2.default.PropTypes.func.isRequired
};
exports.default = Modal;